/*
    Copyright (C) 1999 Paul Barton-Davis 

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    $Id: control_device.h,v 1.3 2000/09/07 16:21:41 pbd Exp $
*/

#ifndef __alsa_control_device_h__
#define __alsa_control_device_h__

/* XXX REMOVE THIS HACK WHEN C++ COMPATIBILITY RETURNS TO asound.h */

#define class category
#include <linux/asound.h>
#undef class

#include <sys/asoundlib.h>
#include <sigc++/signal_system.h>
#include <glib.h>
#include <gdk/gdk.h>

namespace ALSA {

class ControlDevice : public SigC::Object {
  public:
	ControlDevice (snd_ctl_t *hndle);
	~ControlDevice ();

	static void gdk_read (void *arg, gint fd, GdkInputCondition cond);
	SigC::Signal2<void,snd_ctl_t *,snd_ctl_event_t &> changed;

  private:
	snd_ctl_t *handle;
	snd_ctl_event_t data;
	gint gdk_input_tag;
	int read ();
};

}; /* namespace ALSA */

#endif /* __alsa_control_device_h__ */
