/*
    Copyright (C) 1999 Paul Barton-Davis 

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    $Id: monitored_switch.cc,v 1.5 2000/09/07 16:21:41 pbd Exp $
*/

#include "monitored_switch.h"
#include <gtk/gtk.h>

using namespace ALSA;

MonitoredSwitch::MonitoredSwitch (snd_ctl_t *hndle, 
				  const char *namestr,
				  unsigned int period_msecs)

{
	handle = hndle;

	my_switch.indirect = 0;

	my_switch.id.iface = SND_CONTROL_IFACE_PCM;
	my_switch.id.device = 0;
	my_switch.id.subdevice = 0;
	my_switch.id.index = 0;
	my_switch.id.numid = 0;

	strncpy ((char *) my_switch.id.name, namestr, sizeof (my_switch.id.name));
	my_switch.id.name[sizeof (my_switch.id.name) - 1] = '\0';

	/* XXX ARRGHH! what is GTK doing in here ? eh ? */

	gtk_timeout_tag = gtk_timeout_add (period_msecs, gtk_check, this);
}

MonitoredSwitch::~MonitoredSwitch ()

{
	/* XXX ARRGHH! what is GTK doing in here ? eh ? */

	gtk_timeout_remove (gtk_timeout_tag);
}

void
MonitoredSwitch::check ()

{
	if (snd_ctl_cread (handle, &my_switch)) {
		return;
	}

	check_me (handle, my_switch);
}

gint
MonitoredSwitch::gtk_check (void *arg)

{
	((MonitoredSwitch *) arg)->check ();
	return TRUE;
}
